<?php
/*
 * Plugin Name: Opt-in Hammer
* Plugin URI: http://epicmarketer.com/software
* Description: Smash your current opt-in rate by up to 30% with Opt-in Hammer!
* Version: 2.1
* Author:  Mike Cowles
* Author URI: http://epicmarketer.com
*/


define('OPTIN_HAMMER_VERSION', '2.1');
define('PLUGIN_OPTIN_HAMMER_DB_VERSION', '2.0');

$pluginUrl = plugins_url() . "/mike-optin-hammer";
$pluginDir = plugin_dir_path( __FILE__ );

$upload = wp_upload_dir();
$upload_dir = $upload['basedir'];
$pluginUploadPath = $upload_dir . '/mike-optin-hammer';
$pluginUploadUrl = $upload['baseurl'] . '/mike-optin-hammer';

define( 'OPTIN_HAMMER_PLUGIN_URL', $pluginUrl);
define( 'OPTIN_HAMMER_PLUGIN_DIR', $pluginDir);
define( 'OPTIN_HAMMER_VERSION_SQL_DIR', OPTIN_HAMMER_PLUGIN_DIR . "/sql" );

define( 'OPTIN_HAMMER_UPLOAD_PATH', $pluginUploadPath );
define( 'OPTIN_HAMMER_UPLOAD_URL', $pluginUploadUrl );
define( 'OPTIN_HAMMER_BTN_IMAGES_URL', OPTIN_HAMMER_UPLOAD_URL . "/images/btn");
define( 'OPTIN_HAMMER_BTN_IMAGES_PATH', OPTIN_HAMMER_UPLOAD_PATH . "/images/btn");
define( 'OPTIN_HAMMER_LIGHTBOX_IMAGES_PATH', OPTIN_HAMMER_UPLOAD_PATH . "/images/lightbox");
define( 'OPTIN_HAMMER_LIGHTBOX_IMAGES_URL', OPTIN_HAMMER_UPLOAD_URL . "/images/lightbox");


register_activation_hook(__FILE__,'OptinHammer::create');

add_action('plugins_loaded', 'OptinHammer::start');


add_filter('admin_title', 'OptinHammer::editTitle', 10, 2);
add_action('admin_menu', 'OptinHammer::adminMenu');
add_shortcode( "mike_optin_hammer", "OptinHammer::generateCode");
add_shortcode( "mike_optin_hammer_thankyou", "OptinHammer::generatThankyouPageShortCode");


global $wpdb;
$tblPlugin = $wpdb->base_prefix . "mike_optinhammer";

class OptinHammer{
	public static $messages = array(

																	1=> "The optin form created successfully",

																	"The optin form details updatd successfully",

																	"The optin form details deleted successfully",
																	"The optin form details copied successfully",

																	);

	public function __construct(){}

	public static function create()

	{

	  // Variables

	  global $tblPlugin, $wpdb;



	  // Needed to use dbdelta.

	  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');



	  $option_db_version = get_option( "optin_hammer_db_version");



	  if( $wpdb->get_var("SHOW TABLES LIKE '$tblPlugin'") != $tblPlugin ||
	  $option_db_version != PLUGIN_OPTIN_HAMMER_DB_VERSION ) {


	    $sql = file_get_contents( OPTIN_HAMMER_VERSION_SQL_DIR . "/install.sql" );

	    $sql = str_replace( "#__", $wpdb->prefix, $sql );


	    dbDelta($sql);
	    update_option('optin_hammer_db_version', PLUGIN_OPTIN_HAMMER_DB_VERSION );

	  }
	  add_option('optin_hammer_db_version', PLUGIN_OPTIN_HAMMER_DB_VERSION );
      
      // folder create 
      self::upload_folder_creation();

	}

	// Starts the survey manager.

	public static function start()

	{
	  self::create	();

	}
	// delete optin form
	public static function deleteOptinForm(){

    global $wpdb, $tblPlugin;

		$id = $_GET['id'];
		$wpdb->delete( $tblPlugin, array("id" => $id), array( '%d' ));
		wp_redirect(admin_url("admin.php?page=mike-optin-hammer&message=3"));

	}
	public static function cloneOptinForm(){

		global $wpdb, $tblPlugin;
		$id = $_GET['id'];
		$query = "SELECT * FROM $tblPlugin WHERE id='$id'";

		$optinForm = $wpdb->get_row( $query );
		// print_r( $optinForm ); exit;
		$optinForm->form_name .= " clone";
		$optinForm->view_count = 0;
		$optinForm->click_count = 0;
		unset($optinForm->id);
		$wpdb->insert( $tblPlugin, (array) $optinForm  );
		
		wp_redirect(admin_url("admin.php?page=mike-optin-hammer&message=4"));
	
		}
	

 // list optin form

 public static function listOptinForm(){

    global $wpdb, $tblPlugin;

		if( @$_GET['action'] == "delete" ){

			OptinHammer::deleteOptinForm();

		}

		if( @$_GET['action'] == "clone" ){

			OptinHammer::cloneOptinForm();

		}

 		$query = "select id, heading, trigger_btn_type, subheading, listname, form_name, webform_id, responder_type, view_count, click_count, CASE  WHEN view_count <> 0 AND click_count <> 0 THEN click_count / view_count ELSE 0  END AS conversion_rate from $tblPlugin where 1 order by conversion_rate DESC";

		$results = $wpdb->get_results( $query ) ;

		echo "<div class='wrap'>";

		echo "<h2>Opt-in Hammer - List <a class='add-new-h2' href='admin.php?page=edit-mike-optin-hammer'>Add New</a></h2>";

		//echo "<h4>Let your customer tell you what they want before presenting your customized offer!</h4>";

		if( isset($_GET['message']) ){

			echo "<div class='updated below-h2'><p>" . OptinHammer::$messages[$_GET['message']] . "</p></div>";

		}



		echo "<table class='widefat wp-list-table ' >";

		echo "<tr><th>ID</th><th>Heading</th><th>Visitors</th><th align='center'>Conversion Rate</th><th>Form Name</th><th> Actions </th></tr>";

		foreach( $results as $key => $result ){
			$conversionRate = round(100 * $result->conversion_rate);
			$trClass = ($key % 2 == 0 )?"alternate":"";
      $shortCode = "[mike_optin_hammer id='{$result->id}']";
      if( $result->responder_type == "awber"){
        $listNameWebForm = $result->listname;
      } else if( $result->responder_type == "gr"){
        $listNameWebForm = $result->webform_id;
      } else {
        $listNameWebForm = "Aweber: " . $result->listname;
        $listNameWebForm .= "<br/> GR: " . $result->webform_id;
      }

      $result->heading = stripslashes( $result->heading );
      $result->subheading = stripslashes($result->subheading);
			echo "<tr class='$trClass format-standard'><td>{$result->id}</td><td ><a  class='row-title' href=\"?page=edit-mike-optin-hammer&id={$result->id}\">{$result->heading}</a><br/>{$result->subheading}</td><td>{$result->view_count}</td><td>{$conversionRate}%</td><td>{$result->form_name}</td><td><a href=\"admin.php?page=mike-optin-hammer&amp;action=clone&amp;id={$result->id}&noheader=true\">Clone</a> | <a href=\"admin.php?page=edit-mike-optin-hammer&id={$result->id}\">Edit</a> | <a onclick=\"return confirm('Are you sure you want to delete the opt-in form?')\" href=\"admin.php?page=mike-optin-hammer&amp;action=delete&amp;id={$result->id}&noheader=true\">Delete</td></tr>";

		}

		if( count( $results ) == 0 ){

			echo "<tr><td colspan=\"6\" align=\"center\"><h3>There are no optin forms created yet.</h3></td></tr>";

		}

		echo "</table>";

		echo "</div>";

 }



	public static function editTitle($admin_title, $title){

		if( @$_GET['id'] ){

			return str_replace($title, 'Edit Opt-in Form', $admin_title );

		} else {

			return $admin_title;

		}



	}

 // edit optin form

 public static function editOptinForm( ){

	global $wpdb, $tblPlugin;
	$id = @$_GET['id'];

	if( isset($_POST['generateButton'] )){
		OptinHammer::postback();
	}

	// existing survey details

	if( "" != $id && 0 != $id ) {

		// get survey details

		$query = "SELECT * FROM $tblPlugin WHERE id='$id'";

		$optinForm = $wpdb->get_row( $query );

        $optinForm->heading = stripslashes( $optinForm->heading );
        $optinForm->subheading = stripslashes($optinForm->subheading );
        $optinForm->trigger_btn_text = stripslashes($optinForm->trigger_btn_text);
        $optinForm->btn_text = stripslashes($optinForm->btn_text);
		$optinForm->html_code = stripslashes(html_entity_decode($optinForm->html_code));


		$formTitle = "Edit Opt-in Form [ opt-in form id:$id ]";

		$idParam = "&id=" . $id;
		$wpShortCode =  "[mike_optin_hammer id='$id']";
		$wpShortCodeThankyou =  "[mike_optin_hammer_thankyou id='$id']";
		$code = self::generateCode( array("id" => $id, "mode" => "html") );
		$thankyouCode = self::generateCodeForThankyouPage($id);

	} else { // new survey

		$formTitle = "Add New Opt-in Form";
		$optinForm = new StdClass;
		$optinForm->heading = "";
		$optinForm->subheading = "";
		$optinForm->trigger_btn_type = "text";
		$optinForm->trigger_btn_text = "";
		$optinForm->btn_text = "";
		$optinForm->html_code = "";

		$optinForm->responder_type = "awber";
		$optinForm->listname = "";
		$optinForm->webform_id = "";
		$optinForm->thankyou_page = "";
		$optinForm->name_required = "";
		$optinForm->phone_required = "";
		$optinForm->image_url = "";
		$optinForm->form_name = "";

		// get ordering from the table
		$optinForm->ordering = $wpdb->get_var( "SELECT MAX(ordering) + 1 FROM $tblPlugin");
		$idParam = "";
		$code = "";
		$thankyouCode = "";
		$wpShortCode = "";
		$wpShortCodeThankyou = "";
	}
	self::optin_hammer_header_files();
?>

<div class="wrap">

	<h2>  Opt-in Hammer -  <?php echo $formTitle;?></h2>

  	<br />
		<?php
		if( isset($_GET['message']) ){

			echo "<div class='updated below-h2'><p>" . OptinHammer::$messages[$_GET['message']] . "</p></div>";

		}

		?>
        <form method="post" enctype="multipart/form-data" onsubmit="return validation(this);" action="<?php echo admin_url("admin.php?page=edit-mike-optin-hammer&noheader=true" . $idParam );?>">
        <div style="float:left;padding:10px 10px 10px 20px;margin-right:25px;border:1px solid #ddd;width:400px;">
      <table border="0" >
	  	<tr>
			<td>Form Name</td>
			<td><input type="text" name="form_name" id="form_name"
			value="<?php echo $optinForm->form_name;?>" placeholder="Enter the Form name..." /></td>
		</tr>
			<tr>
				<td>Main Headline</td>
				<td><input type="text" name="heading" id="heading"
					value="<?php echo $optinForm->heading;?>" placeholder="Enter the headline..." /></td>
			</tr>
			<tr>
				<td>Sub Headline</td>
				<td><input type="text" name="subheading" id="subheading"
					value="<?php echo $optinForm->subheading;?>"
					placeholder="Enter the sub headline..." /></td>
			</tr>
<tr>
                <td>Header Image </td>
                <td>
                    <input id="frontImageType_url" type="radio" name="image_type" checked="checked"
                    value="url" /> <label for="frontImageType_url">Url</label> <input
                    id="frontImageType_image" type="radio" name="image_type"
                    value="image" /> <label for="frontImageType_image">Upload Image</label>
                    <div id="frontImageUrlContainer">
                        <input type="text" name="image_url" id="frontImageUrl"
                            value="<?php echo $optinForm->image_url;?>" placeholder="Image Url" />
                    </div>
                    <div id="frontImageContainer" style="display: none">
                        <input type="file" name="frontImage"
                            placeholder="Image Url" />
                    </div></td>
            </tr>
			<tr>
				<td>Lightbox Button</td>
				<td><input type="radio" id="frontBtnType_text" <?php echo ("text" == $optinForm->trigger_btn_type)?'checked="checked"':'';?>
					name="trigger_btn_type" value="text" /> <label for="frontBtnType_text">Text</label>
					<input id="frontBtnType_url" type="radio" name="trigger_btn_type" <?php echo ("url" == $optinForm->trigger_btn_type)?'checked="checked"':'';?>
					value="url" /> <label for="frontBtnType_url">Url</label> <input
					id="frontBtnType_image" type="radio" name="trigger_btn_type"
					value="image" /> <label for="frontBtnType_image">Upload Image</label>
					<div id="frontBtnTextContainer">
						<input type="text" name="trigger_btn_text" id="frontButtonText"
							value="<?php echo $optinForm->trigger_btn_text;?>" placeholder="Button Text" />
					</div>
					<div id="frontBtnImageContainer" style="display: none">
						<input type="file" name="frontButtonImage"
							placeholder="Button Text" />
					</div></td>
			</tr>
			<tr>
				<td>Auto responder type</td>
				<td>
       <?php $optinArray = array( "awber" => "Aweber",
       "gr" => "Getresponse","both" => "Both Aweber and Getresponse", "html" => "HTML" );?>
        <select name="responder_type" id="optinType">
         <?php

  foreach ( $optinArray as $value => $text ) :
    if ($optinForm->responder_type == $value) {
      $sel = "selected=\"selected\"";
    } else {
      $sel = "";
    }
    ?>
         <option <?php echo $sel;?> value="<?php echo $value?>"><?php echo $text;?></option>
         <?php endforeach;?>
        </select>
				</td>
			</tr>
			<tr id="listNameContainer" class="awberform">
				<td><span id="listnamecontainer">List name </span>*</td>
				<td><input type="text" name="listname" id="listName"
					value="<?php echo $optinForm->listname;?>"
					placeholder="List name" /> <img id="awber_tooltip"
					src="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/images/help.png" data-tooltip="sticky1" /></td>
			</tr>
			<tr id="awber_thankyou_container" class="awberform">
			<td>Thank you page</td>
			<td><input type="text" name="thankyou_page" id="thankYouPage"	value="<?php echo $optinForm->thankyou_page;?>" placeholder="Thank you page for aweber " />
			</td>
			</tr>
				<tr class="grform" id="webFormIdContainer" >
				<td>List Campaign Token *</td>
				<td><input type="text" name="webform_id" id="webFormId"
					value="<?php echo $optinForm->webform_id;?>"
					placeholder="Web Form Id" />
					<img
					id="gr_tooltip" src="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/images/help.png"
					data-tooltip="sticky2" /></td>
			</tr>


			<tr class="autoresponder-fields">
				<td>Button Text</td>
				<td><input type="text" name="btn_text" id="buttonText"
					value="<?php echo $optinForm->btn_text;?>" placeholder="Button Text " /></td>
			</tr>

			<tr id="optionalFieldsContainer" class="autoresponder-fields">
				<td>Options Fields</td>
				<td><input type="checkbox" name="name_required" id="name" value="1"
					<?php echo ($optinForm->name_required == 1)?"checked=\"checked\" ":"";?> /><label
					for="name"> Name </label><br /> <input type="checkbox" name="phone_required"
					id="phone" value="1"
					<?php echo ($optinForm->phone_required == 1)?"checked=\"checked\" ":"";?> /><label
					for="phone"> Phone </label></td>
			</tr>

            <tr class="otherresponder-fields" style="display:none;">
            <td colspan="2">
            	Html Code:<br/>
                <textarea name="html_code" style="width:100%;height:50px"><?php echo $optinForm->html_code;?></textarea>
            </td>
			<tr>
			<td></td>
			<td>
		<p class="submit">
			<input type="submit"
				class="button button-primary" name="generateButton"
				id="generateButton" value="Save & Generate Code" />
		</p>

			</td>
			</tr>
		</table>
</div>
<div style="float:left">
<div style="border:1px solid #ddd;padding:10px 10px 10px 20px;margin-right:25px;overflow:hidden">
  <div>
		<h3>Short code for opt-in button </h3>
		<div class="shortCodeContainer">
		<?php echo @$wpShortCode;?></div>
		</div>
		<br clear="all" />
		<div>
		<h3>Short code for thank you page tracking</h3>
		<div class="shortCodeContainer">
		<?php echo @$wpShortCodeThankyou;?></div>
		</div>
		<br clear="all" />
		<br clear="all" />
    
    <h3>Generated code for websites</h3>
		<div class="codeContainer" id="codeContainer">
			<div class="code">
      <?php echo htmlspecialchars( @$code );?>
	   </div>
		</div>
		<br clear="all" />
		<h3>Generated code for thank you page tracking</h3>
		<div class="codeContainer" id="codeContainer">
			<div class="code">
      <?php echo nl2br(htmlspecialchars( @$thankyouCode ));?>
	   </div>
		</div>
  </div>

		<div class="opt-in-help">
      <a target="_blank" href="http://mikecowles.com/optinhammerdl">
        <img src=" http://mikecowles.com/ohhelp.png" style="border:0px" />
      </a>

    </div>

</div>

 </form>

</div>
		<script src="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/js/mike_optin.js"></script>
		<div id="mystickytooltip" class="stickytooltip"">
			<div id="sticky1" class="atip">
				<img src="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/images/listid.png" />
			</div>
			<div id="sticky2" class="atip">
				<img src="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/images/formid.png" />
			</div>

		</div>
<script>
jQuery(document).ready(function(){
	jQuery("#optinType").trigger("change");
 });
</script>

<?php

	}

	// postback

	public static function postback(){

	global $wpdb, $tblPlugin;
	$optinData = $_POST;

  if( $_POST['trigger_btn_type'] == "image" ){
    $imageName = md5 ( time () ) . ".png";
    $destination = OPTIN_HAMMER_BTN_IMAGES_PATH . "/" . $imageName;
    move_uploaded_file ( $_FILES ['frontButtonImage'] ['tmp_name'], $destination );
    $frontButtonText = OPTIN_HAMMER_BTN_IMAGES_URL . "/" . $imageName;
    $optinData['trigger_btn_type'] = "url";
    $optinData['trigger_btn_text'] = $frontButtonText;
	}

  // check for the image for the lightbox
  if( $_POST['image_type'] == "image"){
    $imageName = md5 ( time () ) . ".png";
    $destination = OPTIN_HAMMER_LIGHTBOX_IMAGES_PATH . "/" . $imageName;
    move_uploaded_file ( $_FILES ['frontImage'] ['tmp_name'], $destination );
    //echo $destination . "destination";exit;
    $frontImageUrl = OPTIN_HAMMER_LIGHTBOX_IMAGES_URL . "/" . $imageName;
    $optinData['image_url'] = $frontImageUrl;
  }
	unset( $optinData['frontButtonImage'] );
	unset( $optinData['generateButton'] );
    // version 1.5
    unset( $optinData['frontImage'] );
    unset( $optinData['image_type'] );
	
	$optinData['html_code'] =  preg_replace("|<style\b[^>]*>(.*?)</style>|s", "", $optinData['html_code']);
	$optinData['html_code'] =  preg_replace("|\s+|", " ", $optinData['html_code']);

	$optinData['phone_required'] = ( boolean ) @$optinData['phone_required'];
	$optinData['name_required'] = ( boolean ) @$optinData['name_required'];


	if( $_GET['id'] == ""  || $_GET['id'] == 0 ) {// add
		$wpdb->insert( $tblPlugin, $optinData );
		$id = $wpdb->insert_id;
		$message = 1;
	}// add end
	else { // edit
		$id = $_GET['id'];
		$wpdb->update( $tblPlugin
              , $optinData
              , array("id" => $id)
              , array("%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s" )
              , array("%d")
              );
		$message = 2;

	}

	// success, redirect to list
	//echo "url" . admin_url("?page=mike_survey&message=$message");
	wp_redirect(admin_url("admin.php?page=edit-mike-optin-hammer&id=$id&message=$message"));

	}

   public static function adminMenu(){
      $iconUrl = plugin_dir_url( __FILE__ ) . 'images/optin-hammer.png';
      add_menu_page ( 'Opt-in Hammer', 'Opt-in Hammer', 'activate_plugins', 'mike-optin-hammer', 'OptinHammer::listOptinForm', $iconUrl, '55.16' );
  		add_submenu_page( 'mike-optin-hammer', 'Add New Form', 'Add New Form', 'activate_plugins', 'edit-mike-optin-hammer', 'OptinHammer::editOptinForm');
  		// add_submenu_page( 'mike-optin-hammer', 'Clone New Form', 'Clone', 'activate_plugins', 'clone-mike-optin-hammer', 'OptinHammer::cloneOptinForm');
  }
  /**
   * header files like js, css
   */
  static function optin_hammer_header_files() {
    ?>
  <link href='http://fonts.googleapis.com/css?family=Lato&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
  <link href="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/css/mike_optin.css" rel="stylesheet" />
  <script type="text/javascript" src="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/js/stickytooltip.js">
  /***********************************************
  * Sticky Tooltip script- (c) Dynamic Drive DHTML code library (www.dynamicdrive.com)
  * This notice MUST stay intact for legal use
  * Visit Dynamic Drive at http://www.dynamicdrive.com/ for this script and 100s more
  ***********************************************/
  </script>
  <link rel="stylesheet" type="text/css" href="<?php echo OPTIN_HAMMER_PLUGIN_URL?>/css/stickytooltip.css" />
  <?php
  }
  /**
   * generate code based on the id
   */
  public static function generateCode( $attributes = array() ){
    extract( $attributes );
    if( $id == NULL ){
    	return NULL;
    }

  	/***
  	 * getnerated code for normal html pages
  	 */
  	global $wpdb, $tblPlugin;
		$query = "SELECT * FROM $tblPlugin WHERE id='$id'";

		$optinForm = $wpdb->get_row( $query );

  	$heading = stripslashes( $optinForm->heading );
  	$subheading = stripslashes( $optinForm->subheading );
    // image url
    $imageUrl = trim($optinForm->image_url);
  	  if( $optinForm->thankyou_page == ""){
        $optinForm->thankyou_page = "http://www.aweber.com/thankyou.htm?m=default";
      }

      if ($optinForm->responder_type == "awber") {
  	  $phoneNumberField = "custom Phone";
  	  $actionUrl = "http://www.aweber.com/scripts/addlead.pl";
  	  $extraFields = '<input type="hidden" name="redirect" value="' . $optinForm->thankyou_page . '" id="redirect_' . md5(time()) . '" />';
  	  $extraFields .= '<input type="hidden" name="listname" value="' . $optinForm->listname . '" />';
  	} elseif ($optinForm->responder_type == "gr") {
  	  $phoneNumberField = "custom_phone";
  	  $actionUrl = "https://app.getresponse.com/add_subscriber.html";
  	  $extraFields = "<input type='hidden' name='campaign_token' value ='{$optinForm->webform_id}' />";
          
  	} else  {
      $actionUrl = OPTIN_HAMMER_PLUGIN_URL . "/optin-hammer-post.php";
      $extraFields = '<input type="hidden" name="awber_listname" value="' . $optinForm->listname . '" />';
      $extraFields .= "<input type='hidden' name='gr_webform_id' value ='{$optinForm->webform_id}' />";
      $extraFields .= '<input type="hidden" name="redirect" value="' . $optinForm->thankyou_page . '" id="redirect_' . md5(time()) . '" />';
    } 

  	if( $optinForm->trigger_btn_type == "url" ){
  	  $frontButton = "<img class=\"subscribeOpener\" src=\"" . $optinForm->trigger_btn_text . "\" style='border:none' />";
  	} else {
  	  $frontButton = "<a href=\"#\" class=\"subscribeOpener\">{$optinForm->trigger_btn_text}</a>";
  	}
  	?>

  		  <?php   ob_start();
  		  if( @$mode == "html"):
  		  ?>
  	  <script>
  	        if( !window.jQuery){
  	            document.write("<scr"+"ipt src='<?php echo OPTIN_HAMMER_PLUGIN_URL;?>/js/jquery-1.10.2.js'></scr"+"ipt>");
  	        }
  	      </script>
  	  <?php
  	   endif;
  	  ?>
	  <script>
		var trackURL = "<?php bloginfo('url');?>?mike_optin_hammer=open&id=<?php echo $optinForm->id;?>";
	  </script>
  	  <script src="<?php echo OPTIN_HAMMER_PLUGIN_URL;?>/js/jquery-lightbox.js"></script>
  	  <link href="<?php echo OPTIN_HAMMER_PLUGIN_URL;?>/css/mike_sendy_optcode.css"	rel="stylesheet" />
  	  <div class="mike_javasend_optcode">
  	    <?php echo $frontButton;?>
  	<div class="optinCodeContainer" style="display: none">
  	    <?php if( $imageUrl != "" ):?>
  	<div class="headerImage">
  	    <img src="<?php echo $imageUrl;?>" />
  	</div>
  	<?php endif;?>
  	<div class="heading"><?php echo $heading?></div>
  	<?php if( trim( @$subheading) != ""):?>
  	<div class="subheading"><?php echo $subheading?></div>
  	<?php endif;?>
    <?php if( $optinForm->responder_type != "html"):?>
    <form action="<?php echo $actionUrl;?>" method="POST"	accept-charset="utf-8" >
  	<?php  if($optinForm->name_required == 1):?>
  	<input type="text" name="name" id="name" placeholder="Your Name" /><?php endif; ?>
  	<input type="text" name="email" id="email" placeholder="Best Email" /><?php  if( $optinForm->phone_required == 1):?>
  	<input type="text" name="<?php echo $phoneNumberField;?>" id="phone" placeholder="Your Phone" /><?php endif;
  	echo $extraFields;	
  	?><input type="submit" value="<?php echo $optinForm->btn_text;?>" class="susbcribeBtn" name="submit_optin_hammer" id="submit" />
    </form>
    <?php else:
			$htmlCode = stripslashes(html_entity_decode( $optinForm->html_code));
			$htmlCode = preg_replace("|\s+|", " ", $htmlCode);
			echo $htmlCode ;
		  endif;
	?>
        <div class="spam_hate">&nbsp;</div>
		<img src="<?php bloginfo("url")?>?mike_optin_hammer=visit&id=<?php echo $optinForm->id;?>" />
    </div>
  	</div>
  		  <?php
  		  $content =  wpautop(trim(ob_get_clean()));
  		  return  do_shortcode($content);
  }
 static function generateCodeForThankyouPage($id){
	$clickTrackingCode = get_bloginfo('url') . "?mike_optin_hammer=click&id=$id";
	$code = '<?php
				session_start();
			// Check if the token is already set in the session
			if (!isset($_SESSION["oh_thank_you_page_token_' . $id . '"])) {
				// First page load, set the token
				// Generate a unique token
				$token = bin2hex(random_bytes(16));
    			$_SESSION["oh_thank_you_page_token_' . $id . '"] = $token;
    		?>
			<img src="' . $clickTrackingCode . '" />
			<?php
			}
			?>';
	return $code;
 } 

 static function generatThankyouPageShortCode($data){
	$return = "";
	$id = $data['id'];
	$clickTrackingCode = get_bloginfo('url') . "?mike_optin_hammer=click&id=$id";
	
	if (!isset($_SESSION["oh_thank_you_page_token_" . $id])) {
		$token = bin2hex(random_bytes(16));
		$_SESSION['oh_thank_you_page_token_' . $id] = $token;
		$return = '<img src="' . $clickTrackingCode . '" />';
	}
	return $return;
 }
	// In functions.php or a plugin file

// create upload folder for plugin
  
    static function upload_folder_creation() {
        if (! is_dir(OPTIN_HAMMER_UPLOAD_PATH)) {
           mkdir( OPTIN_HAMMER_UPLOAD_PATH, 0700 );  
            if (! is_dir(OPTIN_HAMMER_UPLOAD_PATH . "/images")) {
               mkdir( OPTIN_HAMMER_UPLOAD_PATH . "/images", 0700 );
                if (! is_dir(OPTIN_HAMMER_BTN_IMAGES_PATH)) {
                    mkdir( OPTIN_HAMMER_BTN_IMAGES_PATH, 0700 );                    
                } 
                if (! is_dir(OPTIN_HAMMER_LIGHTBOX_IMAGES_PATH)) {
                    mkdir( OPTIN_HAMMER_LIGHTBOX_IMAGES_PATH, 0700 );                    
                }                    
            }                  
        }
    } 

	
}

function start_session() {
    if (!session_id()) {
        session_start();
    }
 }
 add_action('init', 'start_session', 1);

if(isset($_GET['mike_optin_hammer']) ){
	if( isset($_GET['id'])) {
        $id = $_GET['id'];
		$trackMode = $_GET['mike_optin_hammer'];
        if($trackMode == 'click'){ // conversion clicks tracking
            $columnName = 'click_count';
        } else if($trackMode == 'open'){ // open optin hammer form by clicking the button before submitting
			$columnName = 'form_open_count';
		} else {
            $columnName = 'view_count';
        }

        $sql = $wpdb->prepare(
            "UPDATE $tblPlugin SET $columnName = $columnName + 1 WHERE id = %d",
            $id
        );
        
        // Execute the query
        $updated = $wpdb->query( $sql );
    }
   
// Serve a 1x1 transparent PNG image
    header('Content-Type: image/png');
    echo base64_decode(
    'R0lGODlhAQABAPAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw=='
    );
	exit;
}

// dashboard magic integration using separate function
	/**
	 * dashboard magic integration 
	 */
if( !function_exists('dashboard_magic_announcement_from_epicmarketer')){
	function dashboard_magic_announcement_from_epicmarketer() {
		global $pagenow;
		$dashboardUrl = "https://epicmarketer.com/dashboard/";
		if( is_admin() && $pagenow == 'index.php') {
			$request = wp_remote_get($dashboardUrl);
			$response = wp_remote_retrieve_body( $request );
			echo "<div class='dashboard_magic_announcement_container' id='dashboard_magic_announcement_container'>";
			//echo "<iframe id='dashboard_magic_announcement_iframe' src='" . OH_DASHBOARD_MAGIC_ANNOUNCEMENT_URL . "' onload='resizeDiv()'></iframe>";
			echo "<div class='dashboard_magic_announcement_block' id='dashboard_magic_announcement_block'>$response</div>";
			
			echo "</div>";
		}
	}
	add_action('admin_notices', 'dashboard_magic_announcement_from_epicmarketer', 1);

}
if( !function_exists('enqueue_dashboard_magic_styles')){
	function enqueue_dashboard_magic_styles() {
		// Enqueue your plugin stylesheet
		wp_enqueue_style('dashboard-magic-style', plugins_url('dashboard.css', __FILE__), array(), '1.0', 'all');
	}
	add_action('admin_enqueue_scripts', 'enqueue_dashboard_magic_styles');
}
